searchNodes=[{"type":"module","title":"WebSockAdapter","doc":"Defines adapters to allow common Web Servers to serve applications via the WebSock API. Also provides a consistent upgrade facility to upgrade Plug.Conn requests to WebSock connections for supported servers.","ref":"WebSockAdapter.html"},{"type":"function","title":"WebSockAdapter.upgrade/4","doc":"Upgrades the provided Plug.Conn connection request to a WebSock connection using the provided WebSock compliant module as a handler. This function returns the passed conn set to an :upgraded state. If early_validate_upgrade is set to true (as it is by default), the request is first examined to determine if it represents a valid WebSocket upgrade. If errors are discovered in the request, a WebSockAdapter.UpgradeError is raised containing information about the failure The provided state value will be used as the argument for WebSock.init/1 once the WebSocket connection has been successfully negotiated. The opts keyword list argument allows a number of options to be set on the WebSocket connection. Not all options may be supported by the underlying HTTP server. Possible values are as follows: early_validate_upgrade : A boolean indicating whether or not WebSockAdapter should attempt to validate the WebSocket upgrade request before returning from this call. The underlying webserver may still perform its own validation during the actual upgrade process, but since this occurs after the Plug.call/2 lifecycle it can be difficult to meaningfully handle failed upgrades. Having WebSockAdapter do its own checks as part of this call helps to alleviate this. Defaults to true timeout : The number of milliseconds to wait after no client data is received before closing the connection. Defaults to 60_000 compress : Whether or not to accept negotiation of a compression extension with the client. Defaults to false max_frame_size : The maximum frame size to accept, in octets. If a frame size larger than this is received the connection will be closed. Defaults to :infinity fullsweep_after : The maximum number of garbage collections before forcing a fullsweep of the WebSocket connection process. Setting this option requires OTP 24 or newer max_heap_size : The maximum size of the websocket process heap in words, or a configuration map. See :erlang.max_heap_size() for more info validate_utf8 : Whether the server should verify that the payload of text and close frames is valid UTF-8. This is required by the protocol specification but in some cases it may be more interesting to disable it in order to save resources. Note that binary frames do not have this UTF-8 requirement and are what should be used under normal circumstances if necessary active_n : (Cowboy only) The number of packets Cowboy will request from the socket at once. This can be used to tweak the performance of the server. Higher values reduce the number of times Cowboy need to request more packets from the port driver at the expense of potentially higher memory being used. This option does not apply to Websocket over HTTP/2","ref":"WebSockAdapter.html#upgrade/4"},{"type":"type","title":"WebSockAdapter.connection_opt/0","doc":"The type of a supported connection option","ref":"WebSockAdapter.html#t:connection_opt/0"},{"type":"module","title":"WebSockAdapter.UpgradeValidation","doc":"Provides validation of WebSocket upgrade requests as described in RFC6455§4.2 &amp; RFC8441§5 The validate_upgrade/1 function is called internally by WebSockAdapter.upgrade/4 ; there is no need to call it yourself before attempting an upgrade (though doing so is harmless)","ref":"WebSockAdapter.UpgradeValidation.html"},{"type":"function","title":"WebSockAdapter.UpgradeValidation.validate_upgrade/1","doc":"Validates that the request satisfies the requirements to issue a WebSocket upgrade response. Validations are performed based on the clauses laid out in RFC6455§4.2 &amp; RFC8441§5 This function does not actually perform an upgrade or change the connection in any way. Regardless of whether or not this function indicates a satisfactory connection, the underlying web server MAY still choose to not perform the upgrade (this scenario likely indicates a discrepancy between the validations done here and those done in the underlying web server &amp; would merit further investigation) Returns :ok if the connection satisfies the requirements for a WebSocket upgrade, and {:error, reason} if not","ref":"WebSockAdapter.UpgradeValidation.html#validate_upgrade/1"},{"type":"function","title":"WebSockAdapter.UpgradeValidation.validate_upgrade!/1","doc":"Raising variant of validate_upgrade/1 . Returns :ok if the connection satisfies the requirements for a WebSocket upgrade, and raises a WebSockAdapter.UpgradeError error if validation fails.","ref":"WebSockAdapter.UpgradeValidation.html#validate_upgrade!/1"},{"type":"exception","title":"WebSockAdapter.UpgradeError","doc":"","ref":"WebSockAdapter.UpgradeError.html"}]